import * as server from '@minecraft/server';
import * as ui from '@minecraft/server-ui';

const world = server.world

world.beforeEvents.chatSend.subscribe((eventData) => {
    const player = eventData.sender;
    const commandPrefix = '!';

    if (eventData.message.startsWith(commandPrefix)) {
        const args = eventData.message.slice(commandPrefix.length).split(' ');
        const command = args[0];

        if (command === 'ahelp') {
            eventData.cancel = true;
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7------------------------------------------------"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Here are all the commands that are currently available:"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}clearchat | §aClears the chat."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}gmc | §aSets your gamemode to creative."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}gms | §aSets your gamemode to survival."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}gma | §aSets your gamemode to adventure."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}gmsp | §aSets your gamemode to spectator."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}tday | §aSets the time to day."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}tmidnight | §aSets the time to midnight."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}tnight | §aSets the time to night."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}tnoon | §aSets the time to noon."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}tsunrise | §aSets the time to sunrise."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}tsunset | §aSets the time to sunset."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}up <NUMBER> | §aTeleports you up that amount of blocks."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}ahelp2 | §aBrings you to the next help page."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7------------------------------------------------"}]}`);
        } else if (command === 'ahelp2') {
            eventData.cancel = true;
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7------------------------------------------------"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}mute <player> | §aMutes a player. §7(EDU)"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}unmute <player> | §aUnmutes a player. §7(EDU)"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}fly <player> | §aMakes you or someone else start flying. §7(EDU)"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}unfly <player> | §aMakes you or someone else stop flying. §7(EDU)"}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}kick <player> | §aKicks a player from the game.}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}wclear | §aSets weather to clear."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}wrain | §aSets weather to rain."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}wthunder | §aSets weather to thunder."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7${commandPrefix}t/w-c | §aClears weather and sets time day."}]}`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7------------------------------------------------"}]}`);
        }
        // Admin commands above
        // Non admin commands below

        else if (command === 'help') {
            eventData.cancel = true;
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7------------------------------------------------"}]}`);
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7${commandPrefix}spawn | §aTeleports you to the spawn"}]}`);
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7${commandPrefix}hub | §aTeleports you to the hub"}]}`);
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7------------------------------------------------"}]}`);
        }

        // Non admin commands above
        // Admin commands below

        else if (command === 'clearchat') {
            eventData.cancel = true;
            for (let i = 0; i < 100; i++) {
                player.runCommandAsync('execute as @s[tag=Staff] run tellraw @a {"rawtext":[{"text":" "}]}');
            }
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @a {"rawtext":[{"text":"§7User §c<§7${player.nameTag}§c> §7has cleared the chat."}]}`);
        } else if (command === 'gmc') {
            eventData.cancel = true;
            player.runCommandAsync('gamemode 1 @s[tag=Staff]');
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Your now in creative mode."}]}`);
        } else if (command === 'gms') {
            eventData.cancel = true;
            player.runCommandAsync('gamemode 0 @s[tag=Staff]');
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Your now in survival mode."}]}`);
        } else if (command === 'gma') {
            eventData.cancel = true;
            player.runCommandAsync('gamemode 2 @s[tag=Staff]');
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Your now in adventure mode."}]}`);
        } else if (command === 'gmsp') {
            eventData.cancel = true;
            player.runCommandAsync('gamemode spectator @s[tag=Staff]');
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Your now in spectator mode."}]}`);
        } else if (command === 'bringall') {
            eventData.cancel = true;
            player.runCommandAsync('tp @a @s[tag=Staff]')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Everyone was teleported to you."}]}`);
        } else if (command === 'tday') {
            eventData.cancel = true;
            player.runCommandAsync('execute as @s[tag=Staff] run time set day')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The time is now day"}]}`);
        } else if (command === 'tmidnight') {
            eventData.cancel = true;
            player.runCommandAsync('execute as @s[tag=Staff] run time set midnight')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The time is now midnight"}]}`);
        } else if (command === 'tnight') {
            eventData.cancel = true;
            player.runCommandAsync('execute as @s[tag=Staff] run time set night')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The time is now night"}]}`);
        } else if (command === 'tnoon') {
            eventData.cancel = true;
            player.runCommandAsync('execute as @s[tag=Staff] run time set noon')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The time is now noon"}]}`);
        } else if (command === 'tsunrise') {
            eventData.cancel = true;
            player.runCommandAsync('execute as @s[tag=Staff] run time set sunrise')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The time is now sunrise"}]}`);
        } else if (command === 'tsunset') {
            eventData.cancel = true;
            player.runCommandAsync('execute as @s[tag=Staff] run time set sunset')
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The time is now sunset"}]}`);
        } else if (command === 'up') {
            const upamount = args[1];
            if (upamount) {
                eventData.cancel = true;
                player.runCommandAsync(`teleport @s[tag=Staff] ~ ~${upamount} ~`);
                player.runCommandAsync(`execute as @s[tag=Staff] run setblock ~ ~-1 ~ glass`);
                player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7Went up §3${upamount} §7blocks."}]}`);
            } else {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§cInvalid usage. Correct usage: ${commandPrefix}up <number>"}]}`);
            }
        } else if (command === 'mute') {
            const muteduser = args[1];

            if (muteduser) {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run ability ${muteduser} mute true`);
                console.warn('§7Remember this command is §aEducation Edition §7only AND usernames are case sensitive!')
            } else {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§cInvalid usage. Correct usage: ${commandPrefix}mute <player>"}]}`);
                console.warn('§7Remember this command is §aEducation Edition §7only AND usernames are case sensitive!')
            }
        } else if (command === 'unmute') {
            const unmuteduser = args[1];

            if (unmuteduser) {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run ability ${unmuteduser} mute false`);
                console.warn('§7Remember this command is §aEducation Edition §7only AND usernames are case sensitive!')
            } else {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§cInvalid usage. Correct usage: ${commandPrefix}unmute <player>"}]}`);
                console.warn('§7Remember this command is §aEducation Edition §7only AND usernames are case sensitive!')
            }
        } else if (command === 'fly') {
            const flyinguser = args[1];

            if (flyinguser) {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run ability ${flyinguser} mayfly true`);
                console.warn('§7Remember this command is §aEducation Edition §7only AND usernames are case sensitive!')
            } else {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run ability @s mayfly true`);
                console.warn('§7Remember this command is §aEducation Edition §7only!')
            }
        } else if (command === 'unfly') {
            const notflyinguser = args[1];

            if (notflyinguser) {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run ability ${notflyinguser} mayfly false`);
                console.warn('§7Remember this command is §aEducation Edition §7only AND usernames are case sensitive!')
            } else {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run ability @s mayfly false`);
                console.warn('§7Remember this command is §aEducation Edition §7only!')
            }
        } else if (command === 'kick') {
            const kickeduser = args[1];

            if (kickeduser) {
                eventData.cancel = true;
                player.runCommandAsync(`execute at @s[tag=Staff] run kick ${kickeduser} §7You have been kicked by a staff member.`);
                console.warn('§7Remember this command is §aCase Sensitive §7for the username part!')
            } else {
                eventData.cancel = true;
                player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§cInvalid usage. Correct usage: ${commandPrefix}kick <player>"}]}`);
                console.warn('§7Remember this command is §aCase Sensitive §7for the username part!')
            }
        } else if (command === 'wclear') {
            eventData.cancel = true;
            player.runCommandAsync(`execute at @s[tag=Staff] run weather clear`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The weather is now clear"}]}`);
        } else if (command === 'wrain') {
            eventData.cancel = true;
            player.runCommandAsync(`execute at @s[tag=Staff] run weather rain`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The weather is now rain"}]}`);
        } else if (command === 'wthunder') {
            eventData.cancel = true;
            player.runCommandAsync(`execute at @s[tag=Staff] run weather thunder`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The weather is now thunder"}]}`);
        } else if (command === 't/w-c') {
            eventData.cancel = true;
            player.runCommandAsync(`execute at @s[tag=Staff] run weather clear`);
            player.runCommandAsync(`execute at @s[tag=Staff] run time set day`);
            player.runCommandAsync(`execute as @s[tag=Staff] run tellraw @s {"rawtext":[{"text":"§7The weather is now clear and the time is day"}]}`);
        }

        // Admin commands above
        // Non admin commands below

        else if (command === 'spawn') {
            eventData.cancel = true;
            player.runCommandAsync(`tp @s -512 68 -4`);
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7Teleported to the spawn."}]}`);
        } else if (command === 'hub') {
            eventData.cancel = true;
            player.runCommandAsync(`tp @s -512 68 -4`);
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7Teleported to the hub."}]}`);
        }

        else {
            eventData.cancel = true;
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cThe command §7<§c${command}§7> §cis not a valid command."}]}`);
        }
    }
});